#include "../include/sv.h"
#include <string.h>
#include <stdbool.h>

static bool is_space(int c) {
    return c == ' ' || c == '\t' || c == '\n' || c == '\r' || c == '\v' || c == '\f';
}

SV sv_str(const char *s){
  SV str = {s == NULL ? 0 : strlen(s), (char *)s};
  return str;
}
SV sv_strn(const char *s, size_t len){
  SV str = {len, (char *) s};
  return str; 
}
SV sv_trim(SV s){
    while (s.len > 0 && is_space((int) *s.buf)) s.buf++, s.len--;
    while (s.len > 0 && is_space((int) *(s.buf + s.len - 1))) s.len--;
    return s;
}
SV sv_trim_left(SV s){
    while (s.len > 0 && is_space((int) *s.buf)) s.buf++, s.len--;
    return s;
}
SV sv_trim_right(SV s){
    while (s.len > 0 && is_space((int) *(s.buf + s.len - 1))) s.len--;
    return s;
}
